#include "SSD1306AsciiAvrI2c.h"
#include "Rotary.h"

#define SW_RESET A0

SSD1306AsciiAvrI2c oled;
Rotary r = Rotary(2, 3);

int8_t enc_dir = 0;
int16_t c = 0;
bool ch_flag  = true;
// --------------------------------------------------------------------------------------------------------
void setup() {
  pinMode(SW_RESET, INPUT_PULLUP);

  attachInterrupt(0, rotary_encoder, CHANGE);
  attachInterrupt(1, rotary_encoder, CHANGE);

  oled.begin(&Adafruit128x32, 0x3C);
  oled.setFont(lcdnums14x24);
  oled.clear();
}
// --------------------------------------------------------------------------------------------------------
void loop() {
  if (ch_flag) {
    ch_flag = false;
    c += enc_dir;
    if (c < 0)
      c = 9999;
    if (c > 9999)
      c = 0;
    show_count(c);
  }

  if (!digitalRead(SW_RESET)) {
    c = 0;
    show_count(c);
  }
}
// --------------------------------------------------------------------------------------------------------
void rotary_encoder() {
  uint8_t result = r.process();

  if (result) {
    ch_flag = true;
    if (result == DIR_CW)
      enc_dir = 1;
    else
      enc_dir = -1;
  }
}
// --------------------------------------------------------------------------------------------------------
void show_count(int16_t cc) {
  uint16_t mc;

  oled.setCursor(36, 1);
  mc = cc / 1000;
  oled.print(mc);
  mc = (cc % 1000);
  if (mc < 100)
    oled.print('0');
  if (mc < 10)
    oled.print('0');
  oled.print(mc);
}
